// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _BOP_ShellFaceClassifier_HeaderFile
#define _BOP_ShellFaceClassifier_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _gp_Pnt_HeaderFile
#include <gp_Pnt.hxx>
#endif
#ifndef _TopoDS_Shell_HeaderFile
#include <TopoDS_Shell.hxx>
#endif
#ifndef _BRep_Builder_HeaderFile
#include <BRep_Builder.hxx>
#endif
#ifndef _BOP_SolidClassifier_HeaderFile
#include <BOP_SolidClassifier.hxx>
#endif
#ifndef _TopTools_DataMapOfShapeShape_HeaderFile
#include <TopTools_DataMapOfShapeShape.hxx>
#endif
#ifndef _BOP_CompositeClassifier_HeaderFile
#include <BOP_CompositeClassifier.hxx>
#endif
#ifndef _TopAbs_State_HeaderFile
#include <TopAbs_State.hxx>
#endif
class BOP_BlockBuilder;
class TopoDS_Shape;



class BOP_ShellFaceClassifier  : public BOP_CompositeClassifier {
public:

  void* operator new(size_t,void* anAddress) 
  {
    return anAddress;
  }
  void* operator new(size_t size) 
  {
    return Standard::Allocate(size); 
  }
  void  operator delete(void *anAddress) 
  {
    if (anAddress) Standard::Free((Standard_Address&)anAddress); 
  }

  
//! Creates a classifier in 3D space, to compare <br>
//! a face with a set of faces, <br>
//! a shell with a set of faces, <br>
//! a shell with a shell <br>
  Standard_EXPORT   BOP_ShellFaceClassifier(const BOP_BlockBuilder& theBlockBuilder);
  
//! Clears  contents of internal state of the object <br>
  Standard_EXPORT     void Clear() ;
  
//! Classify shape <B1> with shape <B2> <br>
  Standard_EXPORT   virtual  TopAbs_State CompareShapes(const TopoDS_Shape& B1,const TopoDS_Shape& B2) ;
  
//! Classify element <E> with shape <B> <br>
  Standard_EXPORT   virtual  TopAbs_State CompareElementToShape(const TopoDS_Shape& E,const TopoDS_Shape& B) ;
  
//! Prepare classification involving shape <B> <br>
//! Calls ResetElement on first element of <B> <br>
  Standard_EXPORT   virtual  void ResetShape(const TopoDS_Shape& B) ;
  
//! Prepare classification involving element <E>. <br>
  Standard_EXPORT   virtual  void ResetElement(const TopoDS_Shape& E) ;
  
//! Add element <E> in the set of elements used in classification. <br>
  Standard_EXPORT     void CompareElement(const TopoDS_Shape& E) ;
  
//! Returns state of classification of 2D point, defined by <br>
//! ResetElement, with the current set of elements, <br>
//! defined by Compare. <br>
  Standard_EXPORT   virtual  TopAbs_State State() ;





protected:





private:



Standard_Boolean myFirstCompare;
gp_Pnt myPoint;
TopoDS_Shell myShell;
BRep_Builder myBuilder;
BOP_SolidClassifier mySolidClassifier;
TopTools_DataMapOfShapeShape myFaceShellMap;


};





// other Inline functions and methods (like "C++: function call" methods)


#endif
